package ru.neroduckale.nerodays;

import net.minecraft.server.level.ServerPlayer;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.entity.LivingEntity;
import net.minecraftforge.event.ServerChatEvent;
import net.minecraftforge.event.TickEvent;
import net.minecraftforge.event.entity.living.LivingDeathEvent;
import net.minecraftforge.event.entity.player.AdvancementEvent;
import net.minecraftforge.event.entity.player.PlayerEvent;
import net.minecraftforge.eventbus.api.SubscribeEvent;

import java.awt.*;
import java.io.IOException;

import static ru.neroduckale.nerodays.nerodays.*;


public class Events {
    private static int days;

    public String getLocalizedDeathMessage(LivingEntity p_19343_, DamageSource dms) {
        LivingEntity livingentity = p_19343_.getKillCredit();
        String s = "death.attack." + dms.msgId;
        String s1 = s + ".player";
        String nicknameKilled = p_19343_.getDisplayName().getString();

        var a = json.get(s).getAsString();
        LOGGER.error(a);
        if (livingentity != null) {
            if (json.get(s1) != null) {
                a = json.get(s1).getAsString();
            }
            return String.format(a, nicknameKilled, livingentity.getDisplayName().getString());
        }
        return String.format(a, nicknameKilled);
    }


    @SubscribeEvent
    public void NewDay(TickEvent.LevelTickEvent worldTickEvent) {
        if (worldTickEvent.level.getDayTime() % 24000 == 0) {
            var a = worldTickEvent.level.getDayTime() / 24000;
            if (days != a) {
                days = (int) a;
            } else {return;}
            var m = "Новый день! День: " + a;
            DiscordWebhook.EmbedObject embed = new DiscordWebhook.EmbedObject()
                .setTitle(m)
                .setColor(Color.white);
            serverwebhook.addEmbed(embed);
            try {
                serverwebhook.execute();
            } catch (IOException exception) {
                LOGGER.error(exception.getMessage());
            }
        }
    }


    @SubscribeEvent
    public void NewMsg(ServerChatEvent event) {
        var nickname = event.getUsername();
        var message = event.getMessage().getString();
        webhook.setUsername(nickname);
        webhook.setContent(message);
        webhook.setAvatarUrl("https://ely.by/services/skins-renderer?url=http://skinsystem.ely.by/skins/%s&scale=10&renderFace=1".formatted(nickname));
        try {
            webhook.execute();
        } catch (IOException exception) {
            LOGGER.error(exception.getMessage());
        }
    }



    @SubscribeEvent
    public void Death(LivingDeathEvent event) {

        if (event.getEntity() instanceof ServerPlayer player) {
            var nickname = player.getDisplayName().getString();
            var prichina = event.getSource();
            var message = nickname + " умер...";
            var chlen = this.getLocalizedDeathMessage(player, prichina);
            DiscordWebhook.EmbedObject embed = new DiscordWebhook.EmbedObject()
                    .setAuthor(message, "", "https://ely.by/services/skins-renderer?url=http://skinsystem.ely.by/skins/%s&scale=10&renderFace=1".formatted(nickname))
                    .setTitle(chlen)
                    .setColor(Color.red);
            serverwebhook.addEmbed(embed);
            try {
                serverwebhook.execute();
            } catch (IOException exception) {
                LOGGER.error(exception.getMessage());
            }

        }
    }


    @SubscribeEvent
    public void onNewAchievement(AdvancementEvent.AdvancementEarnEvent event) {
        if (event.getAdvancement().getDisplay() == null) return;
        String id = event.getAdvancement().getId().getPath().replace("/", ".");

        String description;
        String title;
        if (json.get("advancements.%s.description".formatted(id)).getAsString() == null) {
            description = event.getAdvancement().getDisplay().getDescription().getString();
        } else {
            description = json.get("advancements.%s.description".formatted(id)).getAsString();
        }

        if (json.get("advancements.%s.title".formatted(id)).getAsString() == null) {
            title = event.getAdvancement().getDisplay().getTitle().getString();
        } else {
            title = json.get("advancements.%s.title".formatted(id)).getAsString();
        }

        var nickname = event.getEntity().getDisplayName().getString();
        var message = nickname + " получил ачивку!";
        DiscordWebhook.EmbedObject embed = new DiscordWebhook.EmbedObject()
                .setAuthor(message, "", "https://ely.by/services/skins-renderer?url=http://skinsystem.ely.by/skins/%s&scale=10&renderFace=1".formatted(nickname))
                .setTitle(title)
                .setDescription(description)
                .setColor(Color.green);
        serverwebhook.addEmbed(embed);
        try {
            serverwebhook.execute();
        } catch (IOException exception) {
            LOGGER.error(exception.getMessage());
        }

    }


    @SubscribeEvent
    public void playerJoin(PlayerEvent.PlayerLoggedInEvent event) {
        var nickname = event.getEntity().getDisplayName().getString();
        String message = nickname + " зашел на сервер!";
        DiscordWebhook.EmbedObject embed = new DiscordWebhook.EmbedObject()
                .setAuthor(message, "", "https://ely.by/services/skins-renderer?url=http://skinsystem.ely.by/skins/%s&scale=10&renderFace=1".formatted(nickname))
                .setColor(Color.green);
        serverwebhook.addEmbed(embed);
        try {
            serverwebhook.execute();
        } catch (IOException exception) {
            LOGGER.error(exception.getMessage());
        }
    }
    @SubscribeEvent
    public void playerLeave(PlayerEvent.PlayerLoggedOutEvent event) {
        var nickname = event.getEntity().getDisplayName().getString();
        String message = nickname + " вышел с сервера.";
        DiscordWebhook.EmbedObject embed = new DiscordWebhook.EmbedObject()
                .setAuthor(message, "", "https://ely.by/services/skins-renderer?url=http://skinsystem.ely.by/skins/%s&scale=10&renderFace=1".formatted(nickname))
                .setColor(Color.red);
        serverwebhook.addEmbed(embed);
        try {
            serverwebhook.execute();
        } catch (IOException exception) {
            LOGGER.error(exception.getMessage());
        }
    }
}

